Index: tests/regression/Tesselation/BigConvex/post/ConvexEnvelope.r3d
===================================================================
--- tests/regression/Tesselation/BigConvex/post/ConvexEnvelope.r3d	(revision 565695bc8823d4df417f859cee34ed9b17e3b0b8)
+++ tests/regression/Tesselation/BigConvex/post/ConvexEnvelope.r3d	(revision 565695bc8823d4df417f859cee34ed9b17e3b0b8)
@@ -0,0 +1,277 @@
+# Raster3D object description, created by MoleCuilder
+@header.r3d
+# All atoms as spheres
+2
+  0.777562 -3.65286 1.28459 	0.1	1. 1. 1.
+2
+  0.904762 -3.62316 -0.490507 	0.1	1. 1. 1.
+2
+  1.91486 -2.53606 0.492393 	0.1	1. 1. 1.
+2
+  -0.587138 -0.162455 -0.830407 	0.1	1. 1. 1.
+2
+  -1.53704 -3.60006 0.497793 	0.1	1. 1. 1.
+2
+  -0.771938 -0.223855 1.47919 	0.1	1. 1. 1.
+2
+  -0.300138 -1.62946 2.47449 	0.1	1. 1. 1.
+2
+  2.17906 -1.47276 -0.873307 	0.1	1. 1. 1.
+2
+  -0.586638 -1.38326 -2.92321 	0.1	1. 1. 1.
+2
+  0.438062 -2.68776 -2.23921 	0.1	1. 1. 1.
+2
+  -2.47214 -1.59546 1.71589 	0.1	1. 1. 1.
+2
+  -1.64154 -3.70136 -1.80061 	0.1	1. 1. 1.
+2
+  -2.50954 -2.13946 -1.80561 	0.1	1. 1. 1.
+2
+  1.45166 0.153645 2.50359 	0.1	1. 1. 1.
+2
+  2.04886 -1.35716 1.79219 	0.1	1. 1. 1.
+2
+  1.14346 1.15214 0.320993 	0.1	1. 1. 1.
+2
+  1.75376 -0.319055 -2.99941 	0.1	1. 1. 1.
+2
+  1.01996 1.06104 -2.15101 	0.1	1. 1. 1.
+2
+  -1.71014 0.133845 0.126293 	0.1	1. 1. 1.
+2
+  -2.78704 -0.528955 -1.12651 	0.1	1. 1. 1.
+2
+  -4.76454 -1.89276 0.930293 	0.1	1. 1. 1.
+2
+  -4.18614 -2.49696 -0.640907 	0.1	1. 1. 1.
+2
+  -3.92214 -3.45776 0.834093 	0.1	1. 1. 1.
+2
+  3.60736 1.29684 -2.87381 	0.1	1. 1. 1.
+2
+  -4.75094 -0.0564554 0.311693 	0.1	1. 1. 1.
+2
+  -3.67414 0.606345 1.56439 	0.1	1. 1. 1.
+2
+  3.22946 1.45274 2.47189 	0.1	1. 1. 1.
+2
+  4.33006 2.26874 1.33549 	0.1	1. 1. 1.
+2
+  2.57536 2.54894 1.23139 	0.1	1. 1. 1.
+2
+  4.07696 -0.484155 2.10119 	0.1	1. 1. 1.
+2
+  3.61706 -1.46676 0.692693 	0.1	1. 1. 1.
+2
+  -2.88384 2.33404 -0.0290068 	0.1	1. 1. 1.
+2
+  -3.96064 1.67134 -1.28171 	0.1	1. 1. 1.
+2
+  5.67566 1.42984 -1.78291 	0.1	1. 1. 1.
+2
+  5.10266 2.74254 -0.715907 	0.1	1. 1. 1.
+2
+  6.16236 -0.927955 1.16559 	0.1	1. 1. 1.
+2
+  5.53756 -0.911555 -0.496607 	0.1	1. 1. 1.
+2
+  -4.84774 2.80654 1.40919 	0.1	1. 1. 1.
+2
+  5.68906 1.58194 1.24439 	0.1	1. 1. 1.
+2
+  -5.82304 4.61784 0.0247932 	0.1	1. 1. 1.
+2
+  -4.05744 4.53424 -0.184207 	0.1	1. 1. 1.
+2
+  -5.13424 3.87154 -1.43691 	0.1	1. 1. 1.
+2
+  -6.29174 0.967445 0.583993 	0.1	1. 1. 1.
+2
+  -7.12784 2.53484 0.473393 	0.1	1. 1. 1.
+2
+  -6.43904 1.78854 -0.988307 	0.1	1. 1. 1.
+2
+  7.55546 2.01984 -0.0120068 	0.1	1. 1. 1.
+2
+  0.939662 -3.01666 0.414493 	0.1	1. 1. 1.
+2
+  -0.152738 -1.94716 0.354093 	0.1	1. 1. 1.
+2
+  0.0659622 -1.03376 -0.880907 	0.1	1. 1. 1.
+2
+  -1.50434 -2.59696 0.0723932 	0.1	1. 1. 1.
+2
+  -0.0717378 -1.05346 1.57779 	0.1	1. 1. 1.
+2
+  1.52186 -0.603155 -0.873807 	0.1	1. 1. 1.
+2
+  -0.346038 -1.95996 -2.03011 	0.1	1. 1. 1.
+2
+  -2.63434 -1.74086 0.647893 	0.1	1. 1. 1.
+2
+  -1.61364 -2.66266 -1.47131 	0.1	1. 1. 1.
+2
+  1.36626 -0.519255 1.65039 	0.1	1. 1. 1.
+2
+  1.74646 0.246745 0.389693 	0.1	1. 1. 1.
+2
+  1.78606 0.287745 -2.09451 	0.1	1. 1. 1.
+2
+  -2.65324 -0.381955 -0.0548068 	0.1	1. 1. 1.
+2
+  -3.97304 -2.44796 0.426993 	0.1	1. 1. 1.
+2
+  3.21726 0.635145 0.478793 	0.1	1. 1. 1.
+2
+  3.13516 0.931145 -1.97401 	0.1	1. 1. 1.
+2
+  -3.80794 0.459345 0.492693 	0.1	1. 1. 1.
+2
+  3.34736 1.81094 1.44919 	0.1	1. 1. 1.
+2
+  3.76986 1.05884 -0.855107 	0.1	1. 1. 1.
+2
+  4.05806 -0.522555 1.01199 	0.1	1. 1. 1.
+2
+  -3.82684 1.81824 -0.210007 	0.1	1. 1. 1.
+2
+  5.16496 1.66244 -0.848507 	0.1	1. 1. 1.
+2
+  5.48576 -0.422855 0.476393 	0.1	1. 1. 1.
+2
+  -4.98154 2.65954 0.337493 	0.1	1. 1. 1.
+2
+  5.91796 1.03174 0.331693 	0.1	1. 1. 1.
+2
+  -5.00044 4.01854 -0.365207 	0.1	1. 1. 1.
+2
+  -6.30524 1.93554 0.0833932 	0.1	1. 1. 1.
+2
+  7.32406 1.08574 0.0829932 	0.1	1. 1. 1.
+# All tesselation triangles
+8
+  25. -1.   1. 1. 1.   0.0    0 0 0 2
+  SOLID     1.0 0.0 0.0
+  BACKFACE  0.3 0.3 1.0   0 0
+1
+  7.32406 1.08574 0.0829932 	5.67566 1.42984 -1.78291 	7.55546 2.01984 -0.0120068 	1. 0. 0.
+1
+  7.32406 1.08574 0.0829932 	5.67566 1.42984 -1.78291 	5.53756 -0.911555 -0.496607 	1. 0. 0.
+1
+  7.32406 1.08574 0.0829932 	6.16236 -0.927955 1.16559 	5.53756 -0.911555 -0.496607 	1. 0. 0.
+1
+  1.75376 -0.319055 -2.99941 	3.60736 1.29684 -2.87381 	5.67566 1.42984 -1.78291 	1. 0. 0.
+1
+  1.75376 -0.319055 -2.99941 	5.67566 1.42984 -1.78291 	5.53756 -0.911555 -0.496607 	1. 0. 0.
+1
+  0.438062 -2.68776 -2.23921 	1.75376 -0.319055 -2.99941 	5.53756 -0.911555 -0.496607 	1. 0. 0.
+1
+  0.777562 -3.65286 1.28459 	-0.300138 -1.62946 2.47449 	4.07696 -0.484155 2.10119 	1. 0. 0.
+1
+  -0.300138 -1.62946 2.47449 	1.45166 0.153645 2.50359 	3.22946 1.45274 2.47189 	1. 0. 0.
+1
+  3.22946 1.45274 2.47189 	4.07696 -0.484155 2.10119 	6.16236 -0.927955 1.16559 	1. 0. 0.
+1
+  3.22946 1.45274 2.47189 	6.16236 -0.927955 1.16559 	5.68906 1.58194 1.24439 	1. 0. 0.
+1
+  6.16236 -0.927955 1.16559 	5.68906 1.58194 1.24439 	7.55546 2.01984 -0.0120068 	1. 0. 0.
+1
+  7.32406 1.08574 0.0829932 	6.16236 -0.927955 1.16559 	7.55546 2.01984 -0.0120068 	1. 0. 0.
+1
+  3.22946 1.45274 2.47189 	4.33006 2.26874 1.33549 	5.68906 1.58194 1.24439 	1. 0. 0.
+1
+  4.33006 2.26874 1.33549 	5.68906 1.58194 1.24439 	7.55546 2.01984 -0.0120068 	1. 0. 0.
+1
+  4.33006 2.26874 1.33549 	-4.05744 4.53424 -0.184207 	7.55546 2.01984 -0.0120068 	1. 0. 0.
+1
+  1.45166 0.153645 2.50359 	3.22946 1.45274 2.47189 	-4.84774 2.80654 1.40919 	1. 0. 0.
+1
+  -0.300138 -1.62946 2.47449 	1.45166 0.153645 2.50359 	-4.84774 2.80654 1.40919 	1. 0. 0.
+1
+  -4.76454 -1.89276 0.930293 	-6.29174 0.967445 0.583993 	-7.12784 2.53484 0.473393 	1. 0. 0.
+1
+  -4.76454 -1.89276 0.930293 	-4.84774 2.80654 1.40919 	-7.12784 2.53484 0.473393 	1. 0. 0.
+1
+  -0.300138 -1.62946 2.47449 	-4.76454 -1.89276 0.930293 	-3.92214 -3.45776 0.834093 	1. 0. 0.
+1
+  0.777562 -3.65286 1.28459 	-0.300138 -1.62946 2.47449 	-3.92214 -3.45776 0.834093 	1. 0. 0.
+1
+  0.777562 -3.65286 1.28459 	-1.53704 -3.60006 0.497793 	-3.92214 -3.45776 0.834093 	1. 0. 0.
+1
+  3.22946 1.45274 2.47189 	-4.84774 2.80654 1.40919 	-5.82304 4.61784 0.0247932 	1. 0. 0.
+1
+  -4.84774 2.80654 1.40919 	-5.82304 4.61784 0.0247932 	-7.12784 2.53484 0.473393 	1. 0. 0.
+1
+  0.904762 -3.62316 -0.490507 	0.438062 -2.68776 -2.23921 	-1.64154 -3.70136 -1.80061 	1. 0. 0.
+1
+  0.777562 -3.65286 1.28459 	0.904762 -3.62316 -0.490507 	-1.64154 -3.70136 -1.80061 	1. 0. 0.
+1
+  0.777562 -3.65286 1.28459 	-1.53704 -3.60006 0.497793 	-1.64154 -3.70136 -1.80061 	1. 0. 0.
+1
+  -1.53704 -3.60006 0.497793 	-1.64154 -3.70136 -1.80061 	-3.92214 -3.45776 0.834093 	1. 0. 0.
+1
+  -1.64154 -3.70136 -1.80061 	-4.18614 -2.49696 -0.640907 	-3.92214 -3.45776 0.834093 	1. 0. 0.
+1
+  -0.586638 -1.38326 -2.92321 	0.438062 -2.68776 -2.23921 	-1.64154 -3.70136 -1.80061 	1. 0. 0.
+1
+  -0.586638 -1.38326 -2.92321 	0.438062 -2.68776 -2.23921 	1.75376 -0.319055 -2.99941 	1. 0. 0.
+1
+  -1.64154 -3.70136 -1.80061 	-4.18614 -2.49696 -0.640907 	-6.43904 1.78854 -0.988307 	1. 0. 0.
+1
+  5.10266 2.74254 -0.715907 	-4.05744 4.53424 -0.184207 	-5.13424 3.87154 -1.43691 	1. 0. 0.
+1
+  5.10266 2.74254 -0.715907 	-4.05744 4.53424 -0.184207 	7.55546 2.01984 -0.0120068 	1. 0. 0.
+1
+  3.60736 1.29684 -2.87381 	5.10266 2.74254 -0.715907 	-5.13424 3.87154 -1.43691 	1. 0. 0.
+1
+  -4.18614 -2.49696 -0.640907 	-3.92214 -3.45776 0.834093 	-7.12784 2.53484 0.473393 	1. 0. 0.
+1
+  -4.76454 -1.89276 0.930293 	-3.92214 -3.45776 0.834093 	-6.29174 0.967445 0.583993 	1. 0. 0.
+1
+  -3.92214 -3.45776 0.834093 	-6.29174 0.967445 0.583993 	-7.12784 2.53484 0.473393 	1. 0. 0.
+1
+  -4.18614 -2.49696 -0.640907 	-7.12784 2.53484 0.473393 	-6.43904 1.78854 -0.988307 	1. 0. 0.
+1
+  3.60736 1.29684 -2.87381 	5.67566 1.42984 -1.78291 	5.10266 2.74254 -0.715907 	1. 0. 0.
+1
+  5.67566 1.42984 -1.78291 	5.10266 2.74254 -0.715907 	7.55546 2.01984 -0.0120068 	1. 0. 0.
+1
+  -5.82304 4.61784 0.0247932 	-4.05744 4.53424 -0.184207 	-5.13424 3.87154 -1.43691 	1. 0. 0.
+1
+  -5.13424 3.87154 -1.43691 	-7.12784 2.53484 0.473393 	-6.43904 1.78854 -0.988307 	1. 0. 0.
+1
+  -5.82304 4.61784 0.0247932 	-5.13424 3.87154 -1.43691 	-7.12784 2.53484 0.473393 	1. 0. 0.
+1
+  0.777562 -3.65286 1.28459 	0.904762 -3.62316 -0.490507 	6.16236 -0.927955 1.16559 	1. 0. 0.
+1
+  0.904762 -3.62316 -0.490507 	6.16236 -0.927955 1.16559 	5.53756 -0.911555 -0.496607 	1. 0. 0.
+1
+  0.904762 -3.62316 -0.490507 	0.438062 -2.68776 -2.23921 	5.53756 -0.911555 -0.496607 	1. 0. 0.
+1
+  4.33006 2.26874 1.33549 	-5.82304 4.61784 0.0247932 	-4.05744 4.53424 -0.184207 	1. 0. 0.
+1
+  0.777562 -3.65286 1.28459 	4.07696 -0.484155 2.10119 	6.16236 -0.927955 1.16559 	1. 0. 0.
+1
+  -0.586638 -1.38326 -2.92321 	1.75376 -0.319055 -2.99941 	-5.13424 3.87154 -1.43691 	1. 0. 0.
+1
+  1.75376 -0.319055 -2.99941 	3.60736 1.29684 -2.87381 	-5.13424 3.87154 -1.43691 	1. 0. 0.
+1
+  -0.586638 -1.38326 -2.92321 	-5.13424 3.87154 -1.43691 	-6.43904 1.78854 -0.988307 	1. 0. 0.
+1
+  -0.300138 -1.62946 2.47449 	3.22946 1.45274 2.47189 	4.07696 -0.484155 2.10119 	1. 0. 0.
+1
+  3.22946 1.45274 2.47189 	4.33006 2.26874 1.33549 	-5.82304 4.61784 0.0247932 	1. 0. 0.
+1
+  -0.300138 -1.62946 2.47449 	-4.76454 -1.89276 0.930293 	-4.84774 2.80654 1.40919 	1. 0. 0.
+1
+  -0.586638 -1.38326 -2.92321 	-1.64154 -3.70136 -1.80061 	-6.43904 1.78854 -0.988307 	1. 0. 0.
+9
+#  terminating special property
+# current virtual sphere
+8
+  25.0    0.6     -1.0 -1.0 -1.0     0.2        0 0 0 0
+2
+  -5.78057 0.0148446 0.630493	5	1 0 0
+9
+  terminating special property