Index: tests/regression/Molecules/BondFile/testsuite-molecules-fragmentation-bond-file.at
===================================================================
--- tests/regression/Molecules/BondFile/testsuite-molecules-fragmentation-bond-file.at	(revision e69c87634c601039ae61a1acb0b03fc6b7bddd17)
+++ tests/regression/Molecules/BondFile/testsuite-molecules-fragmentation-bond-file.at	(revision 718542b98ffda42460e79001a427f156caa6bcc9)
@@ -2,5 +2,5 @@
 
 AT_SETUP([Molecules - Fragmentation bonds file])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,bond-file])
 
 file=test.conf
@@ -15,5 +15,5 @@
 AT_SETUP([Molecules - Fragmentation bonds file with Undo])
 AT_XFAIL_IF([/bin/true])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,bond-file,undo])
 
 file=test.conf
@@ -28,5 +28,5 @@
 AT_SETUP([Molecules - Fragmentation bonds file with Redo])
 AT_XFAIL_IF([/bin/true])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,bond-file,redo])
 
 file=test.conf
Index: tests/regression/Molecules/BondFile/testsuite-molecules-tremolo-dbond-file.at
===================================================================
--- tests/regression/Molecules/BondFile/testsuite-molecules-tremolo-dbond-file.at	(revision e69c87634c601039ae61a1acb0b03fc6b7bddd17)
+++ tests/regression/Molecules/BondFile/testsuite-molecules-tremolo-dbond-file.at	(revision 718542b98ffda42460e79001a427f156caa6bcc9)
@@ -2,5 +2,5 @@
 
 AT_SETUP([Molecules - TREMOLO dbond file])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,bond-file])
 
 file=silica.pov1.0000.pdb
@@ -17,5 +17,5 @@
 AT_SETUP([Molecules - TREMOLO dbond file with Undo])
 AT_XFAIL_IF([/bin/true])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,bond-file,undo])
 
 file=silica.pov1.0000.pdb
@@ -32,5 +32,5 @@
 AT_SETUP([Molecules - TREMOLO dbond file with Redo])
 AT_XFAIL_IF([/bin/true])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,bond-file,redo])
 
 file=silica.pov1.0000.pdb
Index: tests/regression/Molecules/Copy/testsuite-molecules-copy-molecule.at
===================================================================
--- tests/regression/Molecules/Copy/testsuite-molecules-copy-molecule.at	(revision e69c87634c601039ae61a1acb0b03fc6b7bddd17)
+++ tests/regression/Molecules/Copy/testsuite-molecules-copy-molecule.at	(revision 718542b98ffda42460e79001a427f156caa6bcc9)
@@ -2,5 +2,5 @@
 
 AT_SETUP([Molecules - Copy molecule])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,copy-molecule])
 
 file=test-copy.xyz
@@ -21,5 +21,5 @@
 
 AT_SETUP([Molecules - Copy molecule with Undo])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,copy-molecule,undo])
 
 file=test-copy.xyz
@@ -40,5 +40,5 @@
 
 AT_SETUP([Molecules - Copy molecule with Redo])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,copy-molecule,redo])
 
 file=test-copy.xyz
Index: tests/regression/Molecules/LinearInterpolationofTrajectories/testsuite-molecules-linear-interpolation-of-trajectories.at
===================================================================
--- tests/regression/Molecules/LinearInterpolationofTrajectories/testsuite-molecules-linear-interpolation-of-trajectories.at	(revision e69c87634c601039ae61a1acb0b03fc6b7bddd17)
+++ tests/regression/Molecules/LinearInterpolationofTrajectories/testsuite-molecules-linear-interpolation-of-trajectories.at	(revision 718542b98ffda42460e79001a427f156caa6bcc9)
@@ -2,5 +2,5 @@
 
 AT_SETUP([Molecules - Linear interpolation])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,linear-interpolation-of-trajectories])
 
 file=test.conf
Index: tests/regression/Molecules/RotateAroundOrigin/testsuite-molecules-rotate-around-origin.at
===================================================================
--- tests/regression/Molecules/RotateAroundOrigin/testsuite-molecules-rotate-around-origin.at	(revision e69c87634c601039ae61a1acb0b03fc6b7bddd17)
+++ tests/regression/Molecules/RotateAroundOrigin/testsuite-molecules-rotate-around-origin.at	(revision 718542b98ffda42460e79001a427f156caa6bcc9)
@@ -2,5 +2,5 @@
 
 AT_SETUP([Molecules - Rotate around origin])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,rotate-around-origin])
 
 file=test.xyz
@@ -33,5 +33,5 @@
 
 AT_SETUP([Molecules - Rotate around origin with Undo])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,rotate-around-origin,undo])
 
 file=test.xyz
@@ -63,5 +63,5 @@
 
 AT_SETUP([Molecules - Rotate around origin with Redo])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,rotate-around-origin,redo])
 
 file=test.xyz
Index: tests/regression/Molecules/RotateAroundSelf/testsuite-molecules-rotate-around-self.at
===================================================================
--- tests/regression/Molecules/RotateAroundSelf/testsuite-molecules-rotate-around-self.at	(revision e69c87634c601039ae61a1acb0b03fc6b7bddd17)
+++ tests/regression/Molecules/RotateAroundSelf/testsuite-molecules-rotate-around-self.at	(revision 718542b98ffda42460e79001a427f156caa6bcc9)
@@ -2,5 +2,5 @@
 
 AT_SETUP([Molecules - Rotate around self])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,rotate-around-self])
 
 file=test.xyz
@@ -33,5 +33,5 @@
 
 AT_SETUP([Molecules - Rotate around self with Undo])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,rotate-around-self,undo])
 
 file=test.xyz
@@ -63,5 +63,5 @@
 
 AT_SETUP([Molecules - Rotate around self with Redo])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,rotate-around-self,redo])
 
 file=test.xyz
Index: tests/regression/Molecules/RotateToPrincipalAxisSystem/testsuite-molecules-rotate-to-principal-axis-system.at
===================================================================
--- tests/regression/Molecules/RotateToPrincipalAxisSystem/testsuite-molecules-rotate-to-principal-axis-system.at	(revision e69c87634c601039ae61a1acb0b03fc6b7bddd17)
+++ tests/regression/Molecules/RotateToPrincipalAxisSystem/testsuite-molecules-rotate-to-principal-axis-system.at	(revision 718542b98ffda42460e79001a427f156caa6bcc9)
@@ -2,5 +2,5 @@
 
 AT_SETUP([Molecules - Rotate to PAS])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,rotate-to-principal-axis-system])
 
 file=test-rotated-z90.xyz
@@ -33,5 +33,5 @@
 AT_SETUP([Molecules - Rotate to PAS with Undo])
 AT_XFAIL_IF([/bin/true])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,rotate-to-principal-axis-system,undo])
 
 file=test-rotated-z90.xyz
@@ -64,5 +64,5 @@
 AT_SETUP([Molecules - Rotate to PAS with Redo])
 AT_XFAIL_IF([/bin/true])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,rotate-to-principal-axis-system,redo])
 
 file=test-rotated-z90.xyz
Index: tests/regression/Molecules/SaveAdjacency/testsuite-molecules-save-adjacency.at
===================================================================
--- tests/regression/Molecules/SaveAdjacency/testsuite-molecules-save-adjacency.at	(revision e69c87634c601039ae61a1acb0b03fc6b7bddd17)
+++ tests/regression/Molecules/SaveAdjacency/testsuite-molecules-save-adjacency.at	(revision 718542b98ffda42460e79001a427f156caa6bcc9)
@@ -2,5 +2,5 @@
 
 AT_SETUP([Molecules - Storing adjacency info])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,save-adjacency])
 
 file=test.conf
Index: tests/regression/Molecules/SaveBonds/testsuite-molecules-save-bonds.at
===================================================================
--- tests/regression/Molecules/SaveBonds/testsuite-molecules-save-bonds.at	(revision e69c87634c601039ae61a1acb0b03fc6b7bddd17)
+++ tests/regression/Molecules/SaveBonds/testsuite-molecules-save-bonds.at	(revision 718542b98ffda42460e79001a427f156caa6bcc9)
@@ -2,5 +2,5 @@
 
 AT_SETUP([Molecules - Storing bond info])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,save-bonds])
 
 file=test.conf
Index: tests/regression/Molecules/SaveSelectedMolecules/testsuite-molecules-save-selected-molecules.at
===================================================================
--- tests/regression/Molecules/SaveSelectedMolecules/testsuite-molecules-save-selected-molecules.at	(revision e69c87634c601039ae61a1acb0b03fc6b7bddd17)
+++ tests/regression/Molecules/SaveSelectedMolecules/testsuite-molecules-save-selected-molecules.at	(revision 718542b98ffda42460e79001a427f156caa6bcc9)
@@ -2,5 +2,5 @@
 
 AT_SETUP([Molecules - Save selected molecules])
-AT_KEYWORDS([Molecules,save,selection])
+AT_KEYWORDS([molecules,save,selection,save-selected-molecules])
 
 file=test.xyz
Index: tests/regression/Molecules/SaveTemperature/testsuite-molecules-save-temperature.at
===================================================================
--- tests/regression/Molecules/SaveTemperature/testsuite-molecules-save-temperature.at	(revision e69c87634c601039ae61a1acb0b03fc6b7bddd17)
+++ tests/regression/Molecules/SaveTemperature/testsuite-molecules-save-temperature.at	(revision 718542b98ffda42460e79001a427f156caa6bcc9)
@@ -2,5 +2,5 @@
 
 AT_SETUP([Molecules - Storing temperature])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,save-temperature])
 
 file=test.conf
Index: tests/regression/Molecules/Translation-Periodic/testsuite-molecules-translation-periodic.at
===================================================================
--- tests/regression/Molecules/Translation-Periodic/testsuite-molecules-translation-periodic.at	(revision e69c87634c601039ae61a1acb0b03fc6b7bddd17)
+++ tests/regression/Molecules/Translation-Periodic/testsuite-molecules-translation-periodic.at	(revision 718542b98ffda42460e79001a427f156caa6bcc9)
@@ -2,5 +2,5 @@
 
 AT_SETUP([Molecules - Translation with periodic boundaries])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,translate-atoms])
 
 file=test.conf
@@ -14,5 +14,5 @@
 
 AT_SETUP([Molecules - Translation with periodic boundaries with Undo])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,translate-atoms,undo])
 
 file=test.conf
@@ -26,5 +26,5 @@
 
 AT_SETUP([Molecules - Translation with periodic boundaries with Redo])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,translate-atoms,redo])
 
 file=test.conf
Index: tests/regression/Molecules/Translation/testsuite-molecules-translation.at
===================================================================
--- tests/regression/Molecules/Translation/testsuite-molecules-translation.at	(revision e69c87634c601039ae61a1acb0b03fc6b7bddd17)
+++ tests/regression/Molecules/Translation/testsuite-molecules-translation.at	(revision 718542b98ffda42460e79001a427f156caa6bcc9)
@@ -2,5 +2,5 @@
 
 AT_SETUP([Molecules - Translation])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,translate-atoms])
 
 file=test.conf
@@ -20,5 +20,5 @@
 
 AT_SETUP([Molecules - Translation with Undo])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,translate-atoms,undo])
 
 file=test.conf
@@ -38,5 +38,5 @@
 
 AT_SETUP([Molecules - Translation with Redo])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,translate-atoms,redo])
 
 file=test.conf
Index: tests/regression/Molecules/VerletIntegration/testsuite-molecules-verlet-integration.at
===================================================================
--- tests/regression/Molecules/VerletIntegration/testsuite-molecules-verlet-integration.at	(revision e69c87634c601039ae61a1acb0b03fc6b7bddd17)
+++ tests/regression/Molecules/VerletIntegration/testsuite-molecules-verlet-integration.at	(revision 718542b98ffda42460e79001a427f156caa6bcc9)
@@ -2,5 +2,5 @@
 
 AT_SETUP([Molecules - Verlet force integration])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,verlet-integration])
 
 file=test.conf
@@ -16,5 +16,5 @@
 AT_SETUP([Molecules - Verlet force integration with Undo])
 AT_XFAIL_IF([/bin/true])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,verlet-integration,undo])
 
 file=test.conf
@@ -30,5 +30,5 @@
 AT_SETUP([Molecules - Verlet force integration with Redo])
 AT_XFAIL_IF([/bin/true])
-AT_KEYWORDS([Molecules])
+AT_KEYWORDS([molecules,verlet-integration,redo])
 
 file=test.conf