Index: tests/Fragmentations/Fragmenting/2-methylcyclohexanone/pre/2-methylcyclohexanone.xyz
===================================================================
--- tests/Fragmentations/Fragmenting/2-methylcyclohexanone/pre/2-methylcyclohexanone.xyz	(revision 878044f2802b7b4799a56748e65367ee5b94e541)
+++ tests/Fragmentations/Fragmenting/2-methylcyclohexanone/pre/2-methylcyclohexanone.xyz	(revision 878044f2802b7b4799a56748e65367ee5b94e541)
@@ -0,0 +1,22 @@
+20
+NCI NSC 524 2-Metilcicloesanone (ITALIAN)
+C    2.1538   -0.9828   -0.0592
+C    0.7532   -0.6233    0.4408
+C    0.4585    0.8269    0.1271
+C   -0.2867   -1.4963   -0.2695
+O    1.3238    1.5584   -0.2904
+C   -0.9481    1.3372    0.3495
+C   -1.6911   -1.0384    0.1276
+C   -1.9262    0.3931   -0.3574
+H    2.8899   -0.3488    0.4350
+H    2.3635   -2.0280    0.1680
+H    2.2058   -0.8277   -1.1369
+H    0.6964   -0.7839    1.5174
+H   -0.1649   -1.4016   -1.3485
+H   -0.1477   -2.5373    0.0223
+H   -1.1657    1.3573    1.4173
+H   -1.0433    2.3407   -0.0654
+H   -2.4294   -1.7002   -0.3251
+H   -1.7907   -1.0743    1.2124
+H   -2.9493    0.6912   -0.1280
+H   -1.7656    0.4430   -1.4344
Index: tests/Fragmentations/Fragmenting/2-methylcyclohexanone/testsuite-fragmenting-2-methylcyclohexanone-order1.at
===================================================================
--- tests/Fragmentations/Fragmenting/2-methylcyclohexanone/testsuite-fragmenting-2-methylcyclohexanone-order1.at	(revision 878044f2802b7b4799a56748e65367ee5b94e541)
+++ tests/Fragmentations/Fragmenting/2-methylcyclohexanone/testsuite-fragmenting-2-methylcyclohexanone-order1.at	(revision 878044f2802b7b4799a56748e65367ee5b94e541)
@@ -0,0 +1,21 @@
+### 2-methylcyclohexanone - order 1
+
+AT_SETUP([Fragmentations - 2-methylcyclohexanone order 1])
+AT_KEYWORDS([fragmentation non-convex-envelope])
+
+MOL=2-methylcyclohexanone
+DISTANCE="2."
+FILENAME="BondFragment"
+
+FragNo=8
+
+file=${MOL}.xyz
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/Fragmentations/Fragmenting/${MOL}/pre/$file $file], 0)
+AT_CHECK([chmod u+w $file], 0)
+
+AT_CHECK([../../molecuilder -i $file -I --select-molecule-by-id 0 -f $FILENAME --order 1 --distance $DISTANCE], 0, [stdout], [stderr])
+AT_CHECK([ls ${FRAGMENTPREFIX}*.conf | wc -l], 0, [stdout], [stderr])
+AT_CHECK([grep $FragNo stdout], 0, [stdout], [stderr])
+
+AT_CLEANUP
+
Index: tests/Fragmentations/Fragmenting/2-methylcyclohexanone/testsuite-fragmenting-2-methylcyclohexanone-order2.at
===================================================================
--- tests/Fragmentations/Fragmenting/2-methylcyclohexanone/testsuite-fragmenting-2-methylcyclohexanone-order2.at	(revision 878044f2802b7b4799a56748e65367ee5b94e541)
+++ tests/Fragmentations/Fragmenting/2-methylcyclohexanone/testsuite-fragmenting-2-methylcyclohexanone-order2.at	(revision 878044f2802b7b4799a56748e65367ee5b94e541)
@@ -0,0 +1,21 @@
+### 2-methylcyclohexanone - order 2
+
+AT_SETUP([Fragmentations - 2-methylcyclohexanone order 2])
+AT_KEYWORDS([fragmentation non-convex-envelope])
+
+MOL=2-methylcyclohexanone
+DISTANCE="2."
+FILENAME="BondFragment"
+
+FragNo=16
+
+file=${MOL}.xyz
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/Fragmentations/Fragmenting/${MOL}/pre/$file $file], 0)
+AT_CHECK([chmod u+w $file], 0)
+
+AT_CHECK([../../molecuilder -i $file -I --select-molecule-by-id 0 -f $FILENAME --order 2 --distance $DISTANCE], 0, [stdout], [stderr])
+AT_CHECK([ls ${FRAGMENTPREFIX}*.conf | wc -l], 0, [stdout], [stderr])
+AT_CHECK([grep $FragNo stdout], 0, [stdout], [stderr])
+
+AT_CLEANUP
+
Index: tests/Fragmentations/Fragmenting/2-methylcyclohexanone/testsuite-fragmenting-2-methylcyclohexanone-order3.at
===================================================================
--- tests/Fragmentations/Fragmenting/2-methylcyclohexanone/testsuite-fragmenting-2-methylcyclohexanone-order3.at	(revision 878044f2802b7b4799a56748e65367ee5b94e541)
+++ tests/Fragmentations/Fragmenting/2-methylcyclohexanone/testsuite-fragmenting-2-methylcyclohexanone-order3.at	(revision 878044f2802b7b4799a56748e65367ee5b94e541)
@@ -0,0 +1,21 @@
+### 2-methylcyclohexanone - order 3
+
+AT_SETUP([Fragmentations - 2-methylcyclohexanone order 3])
+AT_KEYWORDS([fragmentation non-convex-envelope])
+
+MOL=2-methylcyclohexanone
+DISTANCE="2."
+FILENAME="BondFragment"
+
+FragNo=26
+
+file=${MOL}.xyz
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/Fragmentations/Fragmenting/${MOL}/pre/$file $file], 0)
+AT_CHECK([chmod u+w $file], 0)
+
+AT_CHECK([../../molecuilder -i $file -I --select-molecule-by-id 0 -f $FILENAME --order 3 --distance $DISTANCE], 0, [stdout], [stderr])
+AT_CHECK([ls ${FRAGMENTPREFIX}*.conf | wc -l], 0, [stdout], [stderr])
+AT_CHECK([grep $FragNo stdout], 0, [stdout], [stderr])
+
+AT_CLEANUP
+
Index: tests/Fragmentations/Fragmenting/2-methylcyclohexanone/testsuite-fragmenting-2-methylcyclohexanone-order4.at
===================================================================
--- tests/Fragmentations/Fragmenting/2-methylcyclohexanone/testsuite-fragmenting-2-methylcyclohexanone-order4.at	(revision 878044f2802b7b4799a56748e65367ee5b94e541)
+++ tests/Fragmentations/Fragmenting/2-methylcyclohexanone/testsuite-fragmenting-2-methylcyclohexanone-order4.at	(revision 878044f2802b7b4799a56748e65367ee5b94e541)
@@ -0,0 +1,21 @@
+### 2-methylcyclohexanone - order 4
+
+AT_SETUP([Fragmentations - 2-methylcyclohexanone order 4])
+AT_KEYWORDS([fragmentation non-convex-envelope])
+
+MOL=2-methylcyclohexanone
+DISTANCE="2."
+FILENAME="BondFragment"
+
+FragNo=39
+
+file=${MOL}.xyz
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/Fragmentations/Fragmenting/${MOL}/pre/$file $file], 0)
+AT_CHECK([chmod u+w $file], 0)
+
+AT_CHECK([../../molecuilder -i $file -I --select-molecule-by-id 0 -f $FILENAME --order 4 --distance $DISTANCE], 0, [stdout], [stderr])
+AT_CHECK([ls ${FRAGMENTPREFIX}*.conf | wc -l], 0, [stdout], [stderr])
+AT_CHECK([grep $FragNo stdout], 0, [stdout], [stderr])
+
+AT_CLEANUP
+
Index: tests/Fragmentations/Fragmenting/2-methylcyclohexanone/testsuite-fragmenting-2-methylcyclohexanone-order5.at
===================================================================
--- tests/Fragmentations/Fragmenting/2-methylcyclohexanone/testsuite-fragmenting-2-methylcyclohexanone-order5.at	(revision 878044f2802b7b4799a56748e65367ee5b94e541)
+++ tests/Fragmentations/Fragmenting/2-methylcyclohexanone/testsuite-fragmenting-2-methylcyclohexanone-order5.at	(revision 878044f2802b7b4799a56748e65367ee5b94e541)
@@ -0,0 +1,21 @@
+### 2-methylcyclohexanone - order 5
+
+AT_SETUP([Fragmentations - 2-methylcyclohexanone order 5])
+AT_KEYWORDS([fragmentation non-convex-envelope])
+
+MOL=2-methylcyclohexanone
+DISTANCE="2."
+FILENAME="BondFragment"
+
+FragNo=
+
+file=${MOL}.xyz
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/Fragmentations/Fragmenting/${MOL}/pre/$file $file], 0)
+AT_CHECK([chmod u+w $file], 0)
+
+AT_CHECK([../../molecuilder -i $file -I --select-molecule-by-id 0 -f $FILENAME --order 5 --distance $DISTANCE], 0, [stdout], [stderr])
+AT_CHECK([ls ${FRAGMENTPREFIX}*.conf | wc -l], 0, [stdout], [stderr])
+AT_CHECK([grep $FragNo stdout], 0, [stdout], [stderr])
+
+AT_CLEANUP
+
Index: tests/Fragmentations/Fragmenting/2-methylcyclohexanone/testsuite-fragmenting-2-methylcyclohexanone-order6.at
===================================================================
--- tests/Fragmentations/Fragmenting/2-methylcyclohexanone/testsuite-fragmenting-2-methylcyclohexanone-order6.at	(revision 878044f2802b7b4799a56748e65367ee5b94e541)
+++ tests/Fragmentations/Fragmenting/2-methylcyclohexanone/testsuite-fragmenting-2-methylcyclohexanone-order6.at	(revision 878044f2802b7b4799a56748e65367ee5b94e541)
@@ -0,0 +1,21 @@
+### 2-methylcyclohexanone - order 6
+
+AT_SETUP([Fragmentations - 2-methylcyclohexanone order 6])
+AT_KEYWORDS([fragmentation non-convex-envelope])
+
+MOL=2-methylcyclohexanone
+DISTANCE="2."
+FILENAME="BondFragment"
+
+FragNo=
+
+file=${MOL}.xyz
+AT_CHECK([/bin/cp -f ${abs_top_srcdir}/tests/Fragmentations/Fragmenting/${MOL}/pre/$file $file], 0)
+AT_CHECK([chmod u+w $file], 0)
+
+AT_CHECK([../../molecuilder -i $file -I --select-molecule-by-id 0 -f $FILENAME --order 6 --distance $DISTANCE], 0, [stdout], [stderr])
+AT_CHECK([ls ${FRAGMENTPREFIX}*.conf | wc -l], 0, [stdout], [stderr])
+AT_CHECK([grep $FragNo stdout], 0, [stdout], [stderr])
+
+AT_CLEANUP
+