Index: src/UIElements/CommandLineUI/CommandLineDialog.cpp
===================================================================
--- src/UIElements/CommandLineUI/CommandLineDialog.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/CommandLineUI/CommandLineDialog.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * CommandLineDialog.cpp
@@ -5,4 +12,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/CommandLineUI/CommandLineStatusIndicator.cpp
===================================================================
--- src/UIElements/CommandLineUI/CommandLineStatusIndicator.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/CommandLineUI/CommandLineStatusIndicator.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * CommandLineStatusIndicator.cpp
@@ -5,4 +12,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/CommandLineUI/CommandLineUIFactory.cpp
===================================================================
--- src/UIElements/CommandLineUI/CommandLineUIFactory.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/CommandLineUI/CommandLineUIFactory.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * CommandLineUIFactory.cpp
@@ -5,4 +12,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/CommandLineUI/CommandLineWindow.cpp
===================================================================
--- src/UIElements/CommandLineUI/CommandLineWindow.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/CommandLineUI/CommandLineWindow.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * CommandLineWindow.cpp
@@ -5,4 +12,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/Dialog.cpp
===================================================================
--- src/UIElements/Dialog.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/Dialog.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * Dialog.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/Dialog.hpp
===================================================================
--- src/UIElements/Dialog.hpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/Dialog.hpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -255,5 +255,5 @@
     virtual void setResult();
   protected:
-    element * tmp;
+    const element * tmp;
   };
 
@@ -265,6 +265,6 @@
     virtual void setResult();
   protected:
-    element *temp;
-    std::vector<element *> tmp;
+    const element *temp;
+    std::vector<const element *> tmp;
   };
 
Index: src/UIElements/MainWindow.cpp
===================================================================
--- src/UIElements/MainWindow.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/MainWindow.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * Window.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/Menu/ActionMenuItem.cpp
===================================================================
--- src/UIElements/Menu/ActionMenuItem.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/Menu/ActionMenuItem.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * ActionMenuItem.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/Menu/DisplayMenuItem.cpp
===================================================================
--- src/UIElements/Menu/DisplayMenuItem.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/Menu/DisplayMenuItem.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * DisplayMenuItem.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/Menu/Menu.cpp
===================================================================
--- src/UIElements/Menu/Menu.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/Menu/Menu.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * Menu.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/Menu/MenuItem.cpp
===================================================================
--- src/UIElements/Menu/MenuItem.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/Menu/MenuItem.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * MenuItem.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/Menu/QT4/QTMenu.cpp
===================================================================
--- src/UIElements/Menu/QT4/QTMenu.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/Menu/QT4/QTMenu.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * QTMenu.cpp
@@ -6,7 +13,15 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Menu/QT4/QTMenu.hpp"
 
 #include <Qt/qaction.h>
+
+#include "Helpers/MemDebug.hpp"
+
 #include "Menu/MenuItem.hpp"
 
Index: src/UIElements/Menu/SeperatorItem.cpp
===================================================================
--- src/UIElements/Menu/SeperatorItem.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/Menu/SeperatorItem.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * SeperatorItem.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/Menu/SubMenuItem.cpp
===================================================================
--- src/UIElements/Menu/SubMenuItem.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/Menu/SubMenuItem.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * SubMenuItem.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/Menu/TextMenu.cpp
===================================================================
--- src/UIElements/Menu/TextMenu.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/Menu/TextMenu.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * TextMenu.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/QT4/QTDialog.cpp
===================================================================
--- src/UIElements/QT4/QTDialog.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/QT4/QTDialog.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * QTDialog.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "UIElements/QT4/QTDialog.hpp"
@@ -554,5 +566,5 @@
   {
     stringstream sstr;
-    sstr << (*iter).first << "\t" << (*iter).second->name;
+    sstr << (*iter).first << "\t" << (*iter).second->getName();
     inputBox->addItem(QString(sstr.str().c_str()),QVariant((*iter).first));
   }
@@ -589,5 +601,5 @@
   {
     stringstream sstr;
-    sstr << (*iter).first << "\t" << (*iter).second->name;
+    sstr << (*iter).first << "\t" << (*iter).second->getName();
     inputBox->addItem(QString(sstr.str().c_str()),QVariant((*iter).first));
   }
@@ -816,5 +828,5 @@
 }
 
-ElementQTQueryPipe::ElementQTQueryPipe(element **_content, QTDialog *_dialog, QComboBox *_theBox) :
+ElementQTQueryPipe::ElementQTQueryPipe(const element **_content, QTDialog *_dialog, QComboBox *_theBox) :
   content(_content),
   dialog(_dialog),
@@ -832,5 +844,5 @@
 }
 
-ElementsQTQueryPipe::ElementsQTQueryPipe(std::vector<element *>*_content, QTDialog *_dialog, QComboBox *_theBox) :
+ElementsQTQueryPipe::ElementsQTQueryPipe(std::vector<const element *>*_content, QTDialog *_dialog, QComboBox *_theBox) :
   content(_content),
   dialog(_dialog),
@@ -844,5 +856,5 @@
   QVariant data = theBox->itemData(newIndex);
   int idx = data.toInt();
-  element *elemental = World::getInstance().getPeriode()->FindElement(idx);
+  const element *elemental = World::getInstance().getPeriode()->FindElement(idx);
   if(elemental)
     (*content).push_back(elemental);
Index: src/UIElements/QT4/QTDialog.hpp
===================================================================
--- src/UIElements/QT4/QTDialog.hpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/QT4/QTDialog.hpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -451,5 +451,5 @@
   Q_OBJECT
 public:
-  ElementQTQueryPipe(element **_content, QTDialog *_dialog, QComboBox *_theBox);
+  ElementQTQueryPipe(const element **_content, QTDialog *_dialog, QComboBox *_theBox);
   virtual ~ElementQTQueryPipe();
 
@@ -458,5 +458,5 @@
 
 private:
-  element **content;
+  const element **content;
   QTDialog *dialog;
   QComboBox *theBox;
@@ -466,5 +466,5 @@
   Q_OBJECT
 public:
-  ElementsQTQueryPipe(std::vector<element *>*_content, QTDialog *_dialog, QComboBox *_theBox);
+  ElementsQTQueryPipe(std::vector<const element *>*_content, QTDialog *_dialog, QComboBox *_theBox);
   virtual ~ElementsQTQueryPipe();
 
@@ -473,5 +473,5 @@
 
 private:
-  std::vector<element *>*content;
+  std::vector<const element *>*content;
   QTDialog *dialog;
   QComboBox *theBox;
Index: src/UIElements/QT4/QTMainWindow.cpp
===================================================================
--- src/UIElements/QT4/QTMainWindow.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/QT4/QTMainWindow.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * QTMainWindow.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "QTMainWindow.hpp"
@@ -19,4 +31,6 @@
 #include<boost/bind.hpp>
 
+#include "Helpers/MemDebug.hpp"
+
 #include "atom.hpp"
 #include "molecule.hpp"
@@ -32,6 +46,4 @@
 #include "Views/QT4/QTMoleculeView.hpp"
 #include "Views/QT4/QTStatusBar.hpp"
-#include "Helpers/MemDebug.hpp"
-
 
 using namespace std;
Index: src/UIElements/QT4/QTUIFactory.cpp
===================================================================
--- src/UIElements/QT4/QTUIFactory.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/QT4/QTUIFactory.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * QTUIFactory.cpp
@@ -6,17 +13,25 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include <iostream>
 #include <cassert>
 
-using namespace std;
+#include <qapplication.h>
 
-#include <qapplication.h>
 
 #include "UIElements/QT4/QTUIFactory.hpp"
 #include "UIElements/QT4/QTMainWindow.hpp"
 #include "UIElements/QT4/QTDialog.hpp"
+
+#include "Helpers/MemDebug.hpp"
+
 #include "version.h"
 #include "defs.hpp"
-#include "Helpers/MemDebug.hpp"
+
+using namespace std;
 
 QTUIFactory::QTUIFactory() :
@@ -26,5 +41,5 @@
   argv = new char*[1];
   argv[0] = new char[256];
-  strcpy(argv[0],ESPACKVersion);
+  strcpy(argv[0],MOLECUILDERVERSION);
   app = new QApplication(argc,argv);
 }
Index: src/UIElements/TextUI/TextDialog.cpp
===================================================================
--- src/UIElements/TextUI/TextDialog.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/TextUI/TextDialog.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * TextDialog.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -569,5 +581,5 @@
   bool badInput=false;
   bool aborted = false;
-  element * temp = NULL;
+  const element * temp = NULL;
   do{
     badInput = false;
Index: src/UIElements/TextUI/TextStatusIndicator.cpp
===================================================================
--- src/UIElements/TextUI/TextStatusIndicator.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/TextUI/TextStatusIndicator.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * TextStatusIndicator.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/TextUI/TextUIFactory.cpp
===================================================================
--- src/UIElements/TextUI/TextUIFactory.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/TextUI/TextUIFactory.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * TextUIFactory.cpp
@@ -5,4 +12,11 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
 
 #include "UIElements/TextUI/TextUIFactory.hpp"
Index: src/UIElements/TextUI/TextWindow.cpp
===================================================================
--- src/UIElements/TextUI/TextWindow.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/TextUI/TextWindow.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * TextWindow.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/UIFactory.cpp
===================================================================
--- src/UIElements/UIFactory.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/UIFactory.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * UIFactory.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/Views/MethodStringView.cpp
===================================================================
--- src/UIElements/Views/MethodStringView.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/Views/MethodStringView.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * MethodStringView.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/Views/QT4/GLMoleculeView.cpp
===================================================================
--- src/UIElements/Views/QT4/GLMoleculeView.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/Views/QT4/GLMoleculeView.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * GLMoleculeView.cpp
@@ -6,5 +13,12 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "GLMoleculeView.hpp"
+
+#include "Helpers/MemDebug.hpp"
 
 GLMoleculeView::GLMoleculeView(QWidget *parent) :
Index: src/UIElements/Views/QT4/QTMoleculeView.cpp
===================================================================
--- src/UIElements/Views/QT4/QTMoleculeView.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/Views/QT4/QTMoleculeView.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * QTMoleculeView.cpp
@@ -6,9 +13,16 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Views/QT4/QTMoleculeView.hpp"
 
 #include <iostream>
+
+#include "Helpers/MemDebug.hpp"
+
 #include "molecule.hpp"
-
 
 using namespace std;
Index: src/UIElements/Views/QT4/QTStatusBar.cpp
===================================================================
--- src/UIElements/Views/QT4/QTStatusBar.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/Views/QT4/QTStatusBar.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * QTStatusBar.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include <sstream>
@@ -13,4 +25,7 @@
 
 #include "QTStatusBar.hpp"
+
+#include "Helpers/MemDebug.hpp"
+
 #include "World.hpp"
 #include "Helpers/helpers.hpp"
@@ -21,7 +36,7 @@
   QStatusBar(_parent),
   Observer("QTStatusBar"),
-  parent(_parent),
   atomCount(World::getInstance().numAtoms()),
-  moleculeCount(World::getInstance().numMolecules())
+  moleculeCount(World::getInstance().numMolecules()),
+  parent(_parent)
 {
   World::getInstance().signOn(this);
Index: src/UIElements/Views/QT4/QTWorldView.cpp
===================================================================
--- src/UIElements/Views/QT4/QTWorldView.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/Views/QT4/QTWorldView.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * QTWorldView.cpp
@@ -6,9 +13,17 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Views/QT4/QTWorldView.hpp"
 
 #include <iostream>
 
+#include "Helpers/MemDebug.hpp"
+
 #include "atom.hpp"
+#include "Formula.hpp"
 #include "molecule.hpp"
 
@@ -20,5 +35,5 @@
 // these attributes are skiped so far
 const int QTWorldView::COLUMNCOUNT = COLUMNTYPES_MAX;
-const char *QTWorldView::COLUMNNAMES[QTWorldView::COLUMNCOUNT]={"Name","Atoms"/*,"Formula"*/,"Center"/*,"Size"*/};
+const char *QTWorldView::COLUMNNAMES[QTWorldView::COLUMNCOUNT]={"Name","Atoms","Formula"/*,"Size"*/};
 
 QTWorldView::QTWorldView(QWidget * _parent) :
@@ -61,8 +76,5 @@
     const int index = (*iter)->IndexNr;
     QTableWidgetItem *indexWidget = new QTableWidgetItem();
-    // there probably is an easier method to convert ints to QStrings... but i didn't find it
-    stringstream idxsstr;
-    idxsstr << index;
-    indexWidget->setText(QString(idxsstr.str().c_str()));
+    indexWidget->setText(QString::number(index));
     indexWidget->setData(Qt::UserRole,QVariant(index));
     setVerticalHeaderItem(i,indexWidget);
@@ -75,17 +87,13 @@
     const int atomCount = (*iter)->getAtomCount();
     QTableWidgetItem *countWidget= new QTableWidgetItem();
-    stringstream countsstr;
-    countsstr << atomCount;
-    countWidget->setText(QString(countsstr.str().c_str()));
+    countWidget->setText(QString::number(atomCount));
     countWidget->setFlags(Qt::ItemIsSelectable | Qt::ItemIsUserCheckable | Qt::ItemIsEnabled);
     setItem(i,ATOMS,countWidget);
 
-    const Vector center = (*iter)->Center;
-    QTableWidgetItem *centerWidget = new QTableWidgetItem();
-    stringstream centersstr;
-    centersstr << center;
-    centerWidget->setText(QString(centersstr.str().c_str()));
-    setItem(i,CENTER,centerWidget);
-    centerWidget->setFlags(Qt::ItemIsSelectable | Qt::ItemIsUserCheckable | Qt::ItemIsEnabled);
+    const Formula formula = (*iter)->getFormula();
+    QTableWidgetItem *formulaWidget= new QTableWidgetItem();
+    formulaWidget->setText(QString(formula.toString().c_str()));
+    formulaWidget->setFlags(Qt::ItemIsSelectable | Qt::ItemIsUserCheckable | Qt::ItemIsEnabled);
+    setItem(i,ATOMS,formulaWidget);
 
     molSelection[i]=nameWidget->isSelected();
Index: src/UIElements/Views/QT4/QTWorldView.hpp
===================================================================
--- src/UIElements/Views/QT4/QTWorldView.hpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/Views/QT4/QTWorldView.hpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -28,5 +28,5 @@
 
   static const int COLUMNCOUNT;
-  enum {NAME,ATOMS,CENTER,COLUMNTYPES_MAX} COLUMNTYPES;
+  enum {NAME,ATOMS,FORMULA,COLUMNTYPES_MAX} COLUMNTYPES;
   static const char *COLUMNNAMES[];
 
Index: src/UIElements/Views/StreamStringView.cpp
===================================================================
--- src/UIElements/Views/StreamStringView.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/Views/StreamStringView.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * StreamStringView.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/Views/StringView.cpp
===================================================================
--- src/UIElements/Views/StringView.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/Views/StringView.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * StringView.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/UIElements/Views/View.cpp
===================================================================
--- src/UIElements/Views/View.cpp	(revision c6081e5308fdedcfd6d64ecc65f597a8c8fbd17e)
+++ src/UIElements/Views/View.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * View.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"